// JavaScript Document
(function(){
preload("preloader");
AOS.init();
myAos();
offCanvasListener();
textFlip();
setForms();
resetForm('loginForm', 'signinForm');
scrollUp();
spyScroll();
/*********************************************************/
/*Menu items: click to go and collapse in Offcanvas menu */
function offCanvasListener() {
  var navLinks = document.querySelectorAll('#navbar .nav-item')
  var myOffcanvas = document.querySelector('#navbar .offcanvas');
  window.offcanvas = bootstrap.Offcanvas.getOrCreateInstance(myOffcanvas);
  navLinks.forEach((l) => {
    l.addEventListener('click', () => {
      var btn = document.querySelector("#navbar button");
      if (getComputedStyle(btn).display != 'none') {
        window.addEventListener('scroll', watch)
        var ob = l.children[0].href.match(/#(.*)$/)[1];
        ob = document.getElementById(ob);
        if (window.activeLnk != ob) {
          window.activeLnk = ob;
        } else {
          window.offcanvas.hide()
        }
      }
    })
  })

  function watch() {
    var ob = window.activeLnk;
    var hnb = document.getElementById('navbar');
    var top = parseFloat(getComputedStyle(hnb).height);
    var dif = Math.abs(parseFloat(ob.getBoundingClientRect().top)) - top;

    if (dif <= 1) {
      window.removeEventListener('scroll', watch);
      window.offcanvas.hide();
    }
  }
}

/*************************************************************************/
/*Preload animation waiting all document images are loaded*/
function preload(pre) {
  var colImgs = document.getElementsByTagName("img");
  var oPreloader = document.getElementById(pre);
  var img = [];
  document.body.classList.add("noscroll");
  oPreloader.imgs = colImgs.length;
  for (let i = 0; i < colImgs.length; i++) {
    img[i] = new Image();
    img[i].src = colImgs[i].src;
    img[i].addEventListener("load", function () {
      oPreloader = document.getElementById("preloader");
      oPreloader.imgs--;
      if (oPreloader.imgs === 0) {
        document.body.removeChild(oPreloader);
        document.body.classList.remove("noscroll");
      }
    });
  }
}

/********************************************************************************/
/*Animate effecvt in title*/
function textFlip() {
  var blocks = document.querySelectorAll('.flip-block .flip-inner');
  var duration = document.querySelector('.flip-block').dataset.duration;
  var delay = 0;
  for (let i = 0; i < blocks.length; i++) {
    blocks[i].style.transitionDuration = duration + 'ms';
    blocks[i].style.transitionDelay = blocks[i].dataset.delay + 'ms'
  }
  setTimeout(function () {
    document.querySelector('.flip-block').classList.add('action')
  }, 500)
}

/**********************************************************************************/
/*Effect for games section*/
function myAos() {
  document.addEventListener('aos:in:aosgames', gamesOn);
}
/*These two function switch hover effect on in every game card and then switch it off in a sequential way  */
function gamesOn() {
  var games = document.getElementsByClassName('gameItem');
  var order = [0, 1, 2, 3, 7, 6, 5, 4]
  for (let i = 0; i < order.length; i++) {
    setTimeout(() => games[order[i]].classList.add('hover'), 100 * i + 500)
  }
  setTimeout(gamesOff, 1000);
}

function gamesOff() {
  var games = document.getElementsByClassName('gameItem');
  var order = [0, 1, 2, 3, 7, 6, 5, 4]
  for (let i = 0; i < order.length; i++) {
    setTimeout(() => games[order[i]].classList.remove('hover'), 100 * i + 500)
  }
}
/**********************************************************************************/
/*Reset forms validate messages  when  modal is closed */
function resetForm(...ids){
  var formModal 
  for(let i=0; i< ids.length; i++){   
  formModal = document.getElementById(ids[i])
  formModal.addEventListener('hidden.bs.modal', () => {
      let form = event.target.querySelector('form')  
      form.classList.remove('was-validated');
    });
  }
}
/**********************************************************************************/
/*Form validation  */
function setForms() {
  var forms = document.getElementsByTagName('form');
  forms = Array.from(forms);
  forms.forEach(function (form) {
  form.classList.add('needs-validation');
  form.addEventListener('submit', function (event) {
      event.preventDefault();
      if (!form.checkValidity()) {
        event.preventDefault()
        event.stopPropagation()
        form.classList.add('was-validated');
      }
      else{
        var parent = form.dataset.parentModal;
        if (parent != null) {
          parent = bootstrap.Modal.getOrCreateInstance(document.getElementById(parent));
          parent.hide();
        }
        sendForm(form);

      }
    });
  })
}
/*Form data sent using fetch*/
/*In demo the form sends data to file post.php*/
/*post.php return a text: Error or result of processing data */
function sendForm(form) {
  const data = new FormData(form);
  fetch("post.php", {
      method: "POST",
      body: data
    })
    .then(function (response) {
      if (!response.ok) {
        let vnt = document.getElementById('respForm');
        let cont = vnt.querySelector('.modal-body');
        cont.innerHTML = "<p>There was a net error. Please, try again later.</p>";
        vnt = bootstrap.Modal.getOrCreateInstance(vnt);
        vnt.show();
      }
      return response.text();
    })
    .then(function (data) {
      let vnt = document.getElementById('respForm');
      let cont = vnt.querySelector('.modal-body');
      if (data != 'Error') {
        cont.innerHTML = "<p>Thanks you for contacting us</p>" + data;
      } else {
        cont.innerHTML = "<p>Oh, There was an error. Please, try again later. " + data + "</p>";
      }
      vnt = bootstrap.Modal.getOrCreateInstance(vnt);
      vnt.show();
    })
}


/*****************************************************************************/
/* Buttom appears at bottom of page to return to Top of page*/
function scrollUp() {
  //Get the button
  let mybutton = document.getElementById("btn-back-to-top");
  let offset = 20
  // When the user scrolls down 20px (offset) from the top of the document, show the button
  window.onscroll = function () {
    scrollFunction();
  };

  function scrollFunction() {
    if (document.body.scrollTop > offset || document.documentElement.scrollTop > offset) {
      mybutton.style.opacity = "1";
    } else {
      mybutton.style.opacity = "0";
    }
  }
  // When the user clicks on the button, scroll to the top of the document
  mybutton.addEventListener("click", backToTop);

  function backToTop() {
    document.body.scrollTop = 0;
    document.documentElement.scrollTop = 0;
  }
}
/*Move a bottom border below nav menulinks*/  
function spyScroll(){
  const firstScrollSpyEl = document.querySelector('[data-bs-spy="scroll"]')
  firstScrollSpyEl.addEventListener('activate.bs.scrollspy', () => {
    var ms = document.querySelector(".mark-spy")
    ms.style.width = event.relatedTarget.offsetWidth + "px";
    ms.style.left = event.relatedTarget.offsetLeft + "px";
  })
}

})()

